#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLMULTTRANSPOSEMATRIXDPROC glMultTransposeMatrixd;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 4.0, 9.0, 5.0, 1.0 }; /* ֡ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ľܸ١ */
static const GLfloat lightdim[] = { 0.2, 0.2, 0.2, 1.0 }; /* γȻȿͶ */
static const GLfloat lightblk[] = { 0.0, 0.0, 0.0, 1.0 }; /* ζȿͶ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* Ķ١ */

/*
** ƥ
*/
#define TEXWIDTH  512                                     /* ƥ */
#define TEXHEIGHT 512                                     /* ƥι⤵ */

/*
** եƥ
*/
#define USEALPHA 1                                        /* եƥȻ */

/*
** 
*/
static void init(void)
{
  /* ƥγ */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, TEXWIDTH, TEXHEIGHT, 0,
    GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, 0);
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* 񤭹ݥꥴΥƥɸͤΣҤȥƥȤӤԤ褦ˤ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);
  
  /* ⤷ҤͤƥͰʲʤ鿿ʤĤޤ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_LEQUAL);
  
#if USEALPHA
  /* Ӥη̤򥢥եͤȤ */
  glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_ALPHA);
  
  /* եƥȤӴؿʤ͡ */
  glAlphaFunc(GL_GEQUAL, 0.5f);
#else
  /* Ӥη̤ͤȤ */
  glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_LUMINANCE);
#endif
  
  /* ƥɸ˻ɸϤˤʪΤκɸͤѤ */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_Q, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);

  /* ƥɸ򤽤Τޤ (S, T, R, Q) ˻Ȥ */
  static const GLdouble genfunc[][4] = {
    { 1.0, 0.0, 0.0, 0.0 },
    { 0.0, 1.0, 0.0, 0.0 },
    { 0.0, 0.0, 1.0, 0.0 },
    { 0.0, 0.0, 0.0, 1.0 },
  };
  glTexGendv(GL_S, GL_EYE_PLANE, genfunc[0]);
  glTexGendv(GL_T, GL_EYE_PLANE, genfunc[1]);
  glTexGendv(GL_R, GL_EYE_PLANE, genfunc[2]);
  glTexGendv(GL_Q, GL_EYE_PLANE, genfunc[3]);

  /*  */
  glClearColor(0.3, 0.3, 1.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  
  /* ν */
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);

#if defined(WIN32)
  glMultTransposeMatrixd =
    (PFNGLMULTTRANSPOSEMATRIXDPROC)wglGetProcAddress("glMultTransposeMatrixd");
#endif
}


/****************************
** GLUT ΥХåؿ **
****************************/

/* ȥåܡѴؿ */
#include "trackball.h"

/* ؿ */
#include "scene.h"

/* ˥᡼Υ */
#define FRAMES 600

static void display(void)
{
  GLint viewport[4];       /* ӥ塼ݡȤ¸ѡ */
  GLdouble modelview[16];  /* ǥӥ塼Ѵ¸ */
  GLdouble projection[16]; /* ƩѴ¸ѡ */
  static int frame = 0;    /* ե졼Υȡ */
  double t = (double)frame / (double)FRAMES; /* в֡ */

  if (++frame >= FRAMES) frame = 0;

  /*
  ** 裱ƥåסǥץƥκ
  */
  
  /* ǥץХåե򥯥ꥢ */
  glClear(GL_DEPTH_BUFFER_BIT);
  
  /* ߤΥӥ塼ݡȤ¸Ƥ */
  glGetIntegerv(GL_VIEWPORT, viewport);
  
  /* ӥ塼ݡȤƥΥꤹ */
  glViewport(0, 0, TEXWIDTH, TEXHEIGHT);
  
  /* ߤƩѴ¸Ƥ */
  glGetDoublev(GL_PROJECTION_MATRIX, projection);
  
  /* ƩѴñ̹ꤹ */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  /* ֤Ȥ󤬻˼ޤ褦ǥӥ塼Ѵꤹ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluPerspective(40.0, (GLdouble)TEXWIDTH / (GLdouble)TEXHEIGHT, 1.0, 20.0);
  gluLookAt(lightpos[0], lightpos[1], lightpos[2], 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

  /* ꤷǥӥ塼Ѵ¸Ƥ */
  glGetDoublev(GL_MODELVIEW_MATRIX, modelview);

  /* ǥץХåեƤΤǥե졼ХåեˤϽ񤭹ޤʤ */
  glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

  /* äƱդפʤΤǥ饤ƥ󥰤򥪥դˤ */
  glDisable(GL_LIGHTING);

  /* ǥץХåեˤ̤ΥݥꥴαԤϿ褦ˤ */
  glCullFace(GL_FRONT);

  /* 褹 */
  scene(t);

  /* ǥץХåեƤƥž */
  glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, TEXWIDTH, TEXHEIGHT);

  /* ᤹̾ */
  glViewport(viewport[0], viewport[1], viewport[2], viewport[3]);
  glMatrixMode(GL_PROJECTION);
  glLoadMatrixd(projection);
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  glEnable(GL_LIGHTING);
  glCullFace(GL_BACK);
  
  /*
  ** 裲ƥåסΤ
  */
  
  /* ե졼ХåեȥǥץХåե򥯥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* ǥӥ塼Ѵ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ΰ֤ꤹʪΤ˰ư*/
  glTranslated(0.0, 0.0, -10.0);
  
  /* ȥåܡ뼰βžͿ */
  glMultMatrixd(trackballRotation());
  
  /* ΰ֤ꤹ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
#if USEALPHA
  /* 뤵ƤʬǤ뤵 */
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightdim);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightblk);
  
  /* 褹 */
  scene(t);
#endif

  /*
  ** 裳ƥåסʬ褹
  */

  /* ƥѴꤹ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  
  /* ƥɸ [-1,1] ϰϤ [0,1] ϰϤ˼ */
  glTranslated(0.5, 0.5, 0.5);
  glScaled(0.5, 0.5, 0.5);
  
  /* ƥΥǥӥ塼ѴƩѴѤ򤫤 */
  glMultMatrixd(modelview);
  
  /* ߤΥǥӥ塼ѴεѴ򤫤Ƥ */
  glMultTransposeMatrixd(trackballRotation());
  glTranslated(0.0, 0.0, 10.0);
  
  /* ǥӥ塼Ѵ᤹ */
  glMatrixMode(GL_MODELVIEW);
  
  /* ƥޥåԥ󥰤ȥƥɸμưͭˤ */
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  glEnable(GL_TEXTURE_GEN_Q);
  
#if USEALPHA
  /* եƥȤͭˤƱƤʬ褹 */
  glEnable(GL_ALPHA_TEST);
  
  /* ʬȤο޷˽Ťͤ褦˱ԤӴؿѹ */
  glDepthFunc(GL_LEQUAL);
#endif
  
  /* 뤵ʬǤ뤵 */
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  
  /* 褹 */
  scene(t);
  
#if USEALPHA
  /* ԤӴؿ򸵤᤹ */
  glDepthFunc(GL_LESS);
  
  /* եƥȤ̵ˤ */
  glDisable(GL_ALPHA_TEST);
#endif
  
  /* ƥޥåԥ󥰤ȥƥɸμư̵ˤ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  glDisable(GL_TEXTURE_GEN_Q);
  glDisable(GL_TEXTURE_2D);
  
  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* ɥν̾¤ */
  if (w < TEXWIDTH || h < TEXHEIGHT) {
    if (w < TEXWIDTH) w = TEXWIDTH;
    if (h < TEXHEIGHT) h = TEXHEIGHT;
    glutReshapeWindow(w, h);
  }

  /* ȥåܡ뤹ϰ */
  trackballRegion(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(40.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* ȥåܡ볫 */
      trackballStart(x, y);
      break;
    case GLUT_UP:
      /* ȥåܡ */
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* ȥåܡư */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q 򥿥פ齪λ */
    exit(0);
  default:
    break;
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitWindowSize(TEXWIDTH, TEXHEIGHT);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle);
  init();
  glutMainLoop();
  return 0;
}
